stages:
  - build
  - publish
  - deploy

variables:
    GIT_SUBMODULE_STRATEGY: recursive

build:
    stage: build
    image: node:22-alpine
    script: chmod +x ./build.sh && ./build.sh
    artifacts:
        paths:
          - public/
        untracked: true
        expire_in: 2 days

publish:
    stage: publish
    image: docker:latest
    services:
      - docker:dind
    dependencies:
      - build
    before_script:
      - docker login -u $QUAY_CR_USERNAME -p $QUAY_CR_PASSWORD quay.io
      - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    script: chmod +x ./publish.sh && ./publish.sh
    only:
      - tags

deploy:
    stage: deploy
    image: quay.io/curl/curl:latest
    dependencies:
      - publish
    script:
      - >-
        curl --request POST --url "$SCHMUSEK8SER_RESTART_URL" --header "X-API-KEY: $SCHMUSEK8SER_API_KEY"
    only:
      - tags
